#INCLUDE "dcop_pdm.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_dcop_pdm",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_dcop_pdm_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_dcop_pdm_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


*******************************************************
DEFINE CLASS _dcop_pdm AS _pdm_PlugIn && 
   Name="_dcop_pdm"

   ID=3000         && ID of Plug-in
   Type="DCOP" && Typ of plug-in (group)

   Setting=.NULL.
   Par=.NULL.

   oDCOP=.NULL.

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)

      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         llEn=.F.
         SELE (This.ALTab)
         SET ORDER TO "I01"
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "Visual FoxPro - PDM (Example)")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetMD, "Metadata File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Sample of plugin which is add class/object/AND PEM on fly.])

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC

   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in

      This.AddCOPEM(loPar,loSetting,.F.)
      RETURN ""
   ENDPROC


   PROCEDURE QuickAnalyse(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in

      This.AddCOPEM(loPar,loSetting,.T.)
      RETURN .T.
   ENDPROC

   PROCEDURE AddCOPEM(loPar,loSetting,llQuick)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      * llQuick   - 

      LOCAL loPDMs,loPDM,loDCOP
      
      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

*susp
      IF ISNULL(This.oDCOP)
         STORE CREATEOBJECT("_DCOPEM") TO loDCOP,This.oDCOP
      ELSE
         loDCOP=This.oDCOP
      ENDIF

      * MUST BE
      loDCOP.DCOPPar=loPar

* 
*susp

      *************************************
      * Add new class to file (PRG/VCX)
      loDCOP.Reset(loPar.oASC,1,2)
      loDCOP.oRam.OBJNAME="_newclass" && Class Name
      loDCOP.oRam.CLASS="_derivedclass" && Parent class
      loDCOP.oRam.BASECLASS="custom" && Base class
      loDCOP.oRam.CLASSLOC=loPar.File && Classlibrary of parent class
      loDCOP.oRam.RESERVED7="Popis nov tdy" && description
*      loDCOP.oRam.RESERVED8="" && Header file
*      loDCOP.oRam.RESERVED4="" && Toolbar Icon
*      loDCOP.oRam.RESERVED5="" && Container Icon

      loDCOP.aMethods(1).Objname="NewMethod" && Method name
      loDCOP.aMethods(1).RESERVED7="Nov metoda" &&  description
*      loDCOP.aMethods(1).RESERVED8=loRam.RESERVED8
      loDCOP.aMethods(1).Params="a"  && list parameters
      loDCOP.aMethods(1).XXSC="RETURN a" && Source code
      loDCOP.aMethods(1).Inherited=0 && Flag of inherited ( 0-new, 1-inherited)
*      loDCOP.aMethods(1).Flags=_Flags_Protected && Protected method
*      loDCOP.aMethods(1).Flags=_Flags_Hidden  && Hidden method


*!*	              * XXMI M, XXMC M, XXDescF M
      loDCOP.aProperties(1).Objname="NewProperty" && property name
      loDCOP.aProperties(1).RESERVED7="Nov vlastnost" &&  description
      loDCOP.aProperties(1).Value="'a'"  && Value
      loDCOP.aProperties(1).Inherited=0 && Flag of inherited ( 0-new, 1-inherited)

      loDCOP.aProperties(2).Objname="NewArray(10)"
      loDCOP.aProperties(2).RESERVED7="Nov matice"
      loDCOP.aProperties(2).Value="10"
      loDCOP.aProperties(2).Inherited=0

*      loDCOP.aProperties(1).Flags=_Flags_Protected && Protected property
*      loDCOP.aProperties(1).Flags=_Flags_Hidden  && Hidden property

      loPar.oASC.AddCOPEM(loDCOP)


      *************************************
      * Add new object into class and file (PRG/VCX/SCX)
      loDCOP.oRam.OBJNAME="_newclass.o1" && Object Name
      loPar.oASC.AddCOPEM(loDCOP)

      loDCOP.oRam.OBJNAME="_newclass.o2" && Object Name
      loPar.oASC.AddCOPEM(loDCOP)


      RETURN .T.
   ENDPROC


   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_dcop_pdm_par")
   ENDPROC


   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings

      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))
      loSettings.Source=GetINIString(lcSection,"Source",loSettings.Source,254,@lcFile)
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings

      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))
      =WriteINIString(lcSection,"Source",ALLT(loSettings.Source),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object
      loDst.Source=loSrc.Source
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources() && Close other source
      RETURN .T.
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      =DODEFAULT(@loSetting) && Voln pvodn metody
      RETURN .T.
   ENDPROC

ENDDEFINE



****************************************************************
DEFINE CLASS _dcop_pdm_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_dcop_pdm_par"
   OK=.F.
 
   Source="" && Table with meta code for methods/procedures
ENDDEFINE

