#INCLUDE "efrx_frx2any.h"
#INCLUDE "../prgs/main.h"

*******************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_EFRX_FRX2ANY",lcCollate)



*********************************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_EFRX_FRX2ANY_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_EFRX_FRX2ANY_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)

************************************************************************
DEFINE CLASS _EFRX_FRX2ANY AS _pdm_PlugIn && 
   Name="_EFRX_FRX2ANY"

   ID=101         && ID of Plug-in
   Type="EFRX" && 



   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         SELE (This.ALTab)
         SET ORDER TO "I01"
         llEn=.F.
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "FRX2Any")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Plug-in for processing FRX2Any metadata in column COMMENT report/label.])

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC


   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lii,liCount,lcHTML,lix,;
            llSingle,lcComment,lcRow,liz,lcContent,lcReport,llAnyExtract,lcChart,;
            lcURHREF,llExtract,liy,lix,lcAHREF,liReportP,lcFile,lcPom,lcPom2,lcForm,liFormP

      LOCAL ARRAY laReportP(1),laFormP(1)

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)
      
      STORE 0 TO liReportP,liFormP
      STORE "" TO lcHTML,lcContent,lcReport,lcURHREF,lcForm,lcChart

      lcComment=loPar.Ram.COMMENT
      lcFile=UPPER(loPar.File)

      * Hyperlink
      ***********
      * Hyperlink='http://www.neova.ca' 
      * Hyperlink=[http://www.neova.ca] 
      * Hyperlink=NameOfTheField
      * Hyperlink=NameOfTheVariable

      * ChildReport
      *************
      * ReportLink='DrillDownChild.FRX' 
      * ReportLink='C:\MyChildReports\DrillDownChild.FRX' 

      * ReportLinkParameter= lcCharParameter  'Character Parameter' 
      * ReportLinkParameter= lnNumricParameter  7687.0512 
      * ReportLinkParameter= luFieldNameParameter  nItemID
      * ReportLinkParameter= luVariableNameParameter  lnQuantity

      * Content
      *************
      * ReportContents=Clients  
      * ReportContents=Total

      * Run Form
      **************
      * FormLink='C:\MyRunForm\RunAnyFormFromReport.SCX' 
      * FormLinkParameter= lcCharParameter  'Character Parameter' 
      * FormLinkParameter= lnNumricParameter  7687.0512 
      * FormLinkParameter= luFieldNameParameter  nItemID
      * FormLinkParameter= luVariableNameParameter  lnQuantity
      
      * Chart
      **************
      * Chart='Chart place keeper' 
     
      liCount=ALINES(laRows,lcComment)
      lcComment=""
      FOR lii=1 TO liCount
          lcRow=LTRIM(laRows(lii))

          liz=AT_NonSpace(@lcRow,1) && najdi prvn znak
          liz=IIF(liz=0,1,liz)

          llExtract=.F.
          DO CASE
             CASE UPPER(SUBST(lcRow,liz,9))=="HYPERLINK"
                  IF LEN(lcURHREF)=0
                     liy=AT_Ex(@lcRow,"=",liz+9) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak

                     IF liy>0
                        lix=AT_Ex(@lcRow,':',liy+2)
                        IF lix>0
                           lcAHREF=ALLT(UPPER(SUBSTR(lcRow,liy+1,lix-liy)))
                           IF lcAHREF=="HTTP:" OR lcAHREF=="HTTPS:" OR lcAHREF=="FILE:" OR;
                              lcAHREF=="FTP:" OR lcAHREF=="GOPHER:" OR;
                              lcAHREF=="MAILTO:" OR lcAHREF=="NEWS:" OR lcAHREF=="TELNET:" OR;
                              lcAHREF=="WAIS:"
                              liz=AT_Ex(@lcRow,"'",lix+1) && Najdi ']
                              liz=IIF(liz=0,AT_Ex(@lcRow,"]",lix+1),liz)
                              lcURHREF=[<a href="]+SUBST(lcRow,liy+1,liz-liy-1)+[">]+SUBST(lcRow,liy+1,liz-liy-1)+[</a>]
                           ENDIF
                        ENDIF
                        IF LEN(lcURHREF)=0
                           lcPom=SUBST(lcRow,liy)
                           lcURHREF=m.loPDM.Expr2xhtml(@lcPom)
                        ENDIF
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,14))=="REPORTCONTENTS"
                  IF LEN(lcContent)=0
                     liy=AT_Ex(@lcRow,"=",liz+14) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                     IF liy>0
                        lcPom=SUBST(lcRow,liy)
                        lcPom2=loPDM.FRX.GetObjLinkByName(lcPom)

                        lcContent=IIF(LEN(lcPom2)>0,[<a href="]+lcPom2+[" target="F31">],"")+;
                                  m.loPDM.Expr2xhtml(@lcPom)+;
                                  IIF(LEN(lcPom2)>0,[</a>],"")+m.loPDM.aSpace(21)

                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

                * ReportLinkParameter= lcCharParameter  'Character Parameter'
             CASE UPPER(SUBST(lcRow,liz,19))=="REPORTLINKPARAMETER"
                  liy=AT_Ex(@lcRow,"=",liz+19) && Najdi =
                  liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                  IF liy>0
                     lcPom=ALLT(SUBS(lcRow,liy))
                     lix=AT(" ",lcPom)
                      
                     liReportP=liReportP+1
                     DIME laReportP(liReportP,2)
                     laReportP(liReportP,1)=LEFT(lcPom,lix-1)
                     lcPom=LTRIM(SUBST(lcPom,lix+1))

                     lcPom2=loPDM.FRX.GetObjLinkByName(lcPom)
                     laReportP(liReportP,2)=IIF(LEN(lcPom2)>0,[<a href="]+lcPom2+[" target="F31">],"")+;
                              m.loPDM.Expr2xhtml(@lcPom)+;
                              IIF(LEN(lcPom2)>0,[</a>],"")+m.loPDM.aSpace(21)

                     llExtract=.T.
                  ENDIF

                   * ReportLink='C:\MyChildReports\DrillDownChild.FRX'
              CASE UPPER(SUBST(lcRow,liz,10))=="REPORTLINK"
                   IF LEN(lcReport)=0
                      liy=AT_Ex(@lcRow,"=",liz+10) && Najdi =
                      liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                      IF liy>0
                         lcReport=ALLT(SUBST(lcRow,liy))
                         lcReport=SUBST(lcReport,2,LEN(lcReport)-2)
                         llExtract=.T.
                      ENDIF
                   ELSE
                      llExtract=.T.
                   ENDIF


                  * FormLinkParameter= lcCharParameter  'Character Parameter' 
             CASE UPPER(SUBST(lcRow,liz,17))=="FORMLINKPARAMETER"
                  liy=AT_Ex(@lcRow,"=",liz+17) && Najdi =
                  liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                  IF liy>0
                     lcPom=ALLT(SUBS(lcRow,liy))
                     lix=AT(" ",lcPom)
                      
                     liFormP=liFormP+1
                     DIME laFormP(liFormP,2)
                     laFormP(liFormP,1)=LEFT(lcPom,lix-1)
                     lcPom=LTRIM(SUBST(lcPom,lix+1))

                     lcPom2=loPDM.FRX.GetObjLinkByName(lcPom)
                     laFormP(liFormP,2)=IIF(LEN(lcPom2)>0,[<a href="]+lcPom2+[" target="F31">],"")+;
                              m.loPDM.Expr2xhtml(@lcPom)+;
                              IIF(LEN(lcPom2)>0,[</a>],"")+m.loPDM.aSpace(21)

                     llExtract=.T.
                  ENDIF

                  * FormLink='C:\MyRunForm\RunAnyFormFromReport.SCX' 
              CASE UPPER(SUBST(lcRow,liz,8))=="FORMLINK"
                   IF LEN(lcForm)=0
                      liy=AT_Ex(@lcRow,"=",liz+8) && Najdi =
                      liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                      IF liy>0
                         lcForm=ALLT(SUBST(lcRow,liy))
                         lcForm=SUBST(lcForm,2,LEN(lcForm)-2)
                         llExtract=.T.
                      ENDIF
                   ELSE
                      llExtract=.T.
                   ENDIF


                   * Chart='Chart place keeper' 
              CASE UPPER(SUBST(lcRow,liz,5))=="CHART"
                   IF LEN(lcChart)=0
                      liy=AT_Ex(@lcRow,"=",liz+5) && Najdi =
                      liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                      IF liy>0
                         lcChart=ALLT(SUBST(lcRow,liy))
                         lcChart=SUBST(lcChart,2,LEN(lcChart)-2)
                         llExtract=.T.
                      ENDIF
                   ELSE
                      llExtract=.T.
                   ENDIF


          ENDCASE
          llAnyExtract=llAnyExtract OR llExtract
          IF !llExtract
             lcComment=lcComment+lcRow+CRLF
          ENDIF
      NEXT

      IF llAnyExtract
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[<table><tbody>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURHREF)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_frx2any_td_bold">]+This.GetHTMLString(PI_HTML_Hyperlink)+[</td><td>]+lcURHREF+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcContent)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_frx2any_td_bold">]+This.GetHTMLString(PI_HTML_Content)+[</td><td>]+lcContent+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcReport)>0 OR liReportP>0
         lcPom=IIF(EMPTY(lcReport),"",loPDMs.GetAnchor(FULLPATH(lcReport,lcFile),"../../"))

         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_frx2any_td_bold efrx_frx2any_td_top">]+This.GetHTMLString(PI_HTML_CReport)+[</td><td>]+;
                                  [<div>]+IIF(EMPTY(lcPom),lcReport,[<a href="]+lcPom+[" target="_blank">]+lcReport+[</a>])+[</div>]+m.loPDM.aSpace(21)

         IF liReportP>0
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(3)+[<div class="efrx_frx2any_Param_head">]+This.GetHTMLString(PI_HTML_Params)+[</div>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(3)+[<table class="efrx_frx2any_Param_table">]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(4)+[<thead>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(5)+[<tr class="efrx_frx2any_Param_table_head"><td>]+This.GetHTMLString(PI_HTML_Name)+[</td><td>]+This.GetHTMLString(PI_HTML_Value)+[</td></tr>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(4)+[</thead>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(4)+[<tbody>]+m.loPDM.aSpace(21)
         ENDIF

         FOR lii=1 TO liReportP
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(5)+[<tr><td>]+laReportP(lii,1)+[</td><td>]+laReportP(lii,2)+[</td></tr>]+m.loPDM.aSpace(21)
         NEXT

         IF liReportP>0
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(4)+[</tbody>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(3)+[</table>]+m.loPDM.aSpace(21)
         ENDIF

         lcHTML=lcHTML+;
                m.loPDM.aSpace(3)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcForm)>0 OR liFormP>0
         lcPom=IIF(EMPTY(lcForm),"",loPDMs.GetAnchor(FULLPATH(lcForm,lcFile),"../../"))

         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_frx2any_td_bold efrx_frx2any_td_top">]+This.GetHTMLString(PI_HTML_Form)+[</td><td>]+;
                                  [<div>]+IIF(EMPTY(lcPom),lcForm,[<a href="]+lcPom+[" target="_blank">]+lcForm+[</a>])+[</div>]+m.loPDM.aSpace(21)

         IF liFormP>0
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(3)+[<div class="efrx_frx2any_Param_head">]+This.GetHTMLString(PI_HTML_Params)+[</div>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(3)+[<table class="efrx_frx2any_Param_table">]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(4)+[<thead>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(5)+[<tr class="efrx_frx2any_Param_table_head"><td>]+This.GetHTMLString(PI_HTML_Name)+[</td><td>]+This.GetHTMLString(PI_HTML_Value)+[</td></tr>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(4)+[</thead>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(4)+[<tbody>]+m.loPDM.aSpace(21)
         ENDIF

         FOR lii=1 TO liFormP
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(5)+[<tr><td>]+laFormP(lii,1)+[</td><td>]+laFormP(lii,2)+[</td></tr>]+m.loPDM.aSpace(21)
         NEXT

         IF liFormP>0
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(4)+[</tbody>]+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(3)+[</table>]+m.loPDM.aSpace(21)
         ENDIF

         lcHTML=lcHTML+;
                m.loPDM.aSpace(3)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcChart)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_frx2any_td_bold efrx_frx2any_td_top">]+This.GetHTMLString(PI_HTML_Chart)+[</td><td>]+;
                                  [<div>]+lcChart+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF llAnyExtract
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[</tbody></table>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcHTML)>0
         lcHTML=m.loPDM.aSpace(1)+"<hr>"+m.loPDM.aSpace(21)+lcHTML
      ENDIF



      loPar.Ram.COMMENT=lcComment

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetSetting()
      RETURN CREATEOBJECT("_EFRX_FRX2ANY_par")
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object
      loDst.CSS=loSrc.CSS
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE")=0
            llEn=.F.
            SELE (This.AHTML)
            SET ORDER TO "I01"
         ENDIF
         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Hyperlink, "Hyperlink:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Content, "Content:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_CReport, "Child Report:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Params, "Parameters:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Name, "Name")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Value, "Value")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Form, "Form:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Chart, "Chart:")

            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      RETURN .T.
   ENDPROC

ENDDEFINE

*********************************************************
DEFINE CLASS _EFRX_FRX2ANY_par AS _pdm_PlugIn_Parameter
   Name="_EFRX_FRX2ANY_par"
   DIME aCSS(1),aJS(1)
   OK=.F.
 
   CSS="efrx_frx2any.css" && Relative to efrx_xfrx.fxp
   JS="" && 

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE


